# coding: utf-8

"""
    Equinix Fabric API v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from equinix.services.fabricv4.models.aws_permission_type import AWSPermissionType
from equinix.services.fabricv4.models.topology_properties import TopologyProperties
from typing import Optional, Set
from typing_extensions import Self

class GCPPermission(BaseModel):
    """
    Provides the GCP permission configuration for the orchestrator. This permission is used to manage the GCP resources and their access control. 
    """ # noqa: E501
    type: AWSPermissionType
    project_id: StrictStr = Field(alias="projectId")
    provider_id: StrictStr = Field(alias="providerId")
    pool_id: StrictStr = Field(alias="poolId")
    deployment_properties: TopologyProperties = Field(alias="deploymentProperties")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["type", "projectId", "providerId", "poolId", "deploymentProperties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GCPPermission from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of deployment_properties
        if self.deployment_properties:
            _dict['deploymentProperties'] = self.deployment_properties.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GCPPermission from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "projectId": obj.get("projectId"),
            "providerId": obj.get("providerId"),
            "poolId": obj.get("poolId"),
            "deploymentProperties": TopologyProperties.from_dict(obj["deploymentProperties"]) if obj.get("deploymentProperties") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


